/* Procedure para incluso de rateio para conta a pagar ou receber*/

   IF EXISTS (SELECT *
              FROM SYSOBJECTS O, SYSUSERS U
              WHERE
	              O.NAME = 'GERA_RATEIO_CONTA'  AND
	              TYPE = 'P'               AND
	              U.UID = O.UID            AND
	              U.NAME = USER)

   DROP PROCEDURE GERA_RATEIO_CONTA
   GO






CREATE  PROCEDURE GERA_RATEIO_CONTA
             @P_IDENTRSAID  VARCHAR(1),
             @P_CDFILIAL    VARCHAR(4),
             @P_LANCAMENTO  VARCHAR(10),
             @P_NRSEQVENC   VARCHAR(2),
             @P_NRPARCELA   VARCHAR(2),
             @P_VRCONTA     double precision,
             @P_CDTIPOCONTA VARCHAR(6),
             @P_CDFILIRAT   VARCHAR(4)
AS
   DECLARE   @V_VALORRAT      double precision;
   DECLARE   @V_RATTPCT       INTEGER;
   DECLARE   @V_CDFILIAL      VARCHAR(4);
   DECLARE   @V_CDCENTCUST    VARCHAR(4);
   DECLARE   @V_CDFIRATTPCTP  VARCHAR(4);
   DECLARE   @V_VRPERATTPCTP  double precision;
   DECLARE   @V_CDTPCTPAGAR   VARCHAR(6);
   DECLARE   @V_CDFIRATTPCTR  VARCHAR(4);
   DECLARE   @V_VRPERATTPCTR  double precision;
   DECLARE   @V_CDTPCTRECEB   VARCHAR(6);
/* Variavei de cursor C_RATTPCTPAG*/
   DECLARE   @V_RATTPCTPAG_CDFILIAL      VARCHAR(4);
   DECLARE   @V_RATTPCTPAG_CDCENTCUST    VARCHAR(4);
   DECLARE   @V_RATTPCTPAG_CDFIRATTPCTP  VARCHAR(4);
   DECLARE   @V_RATTPCTPAG_VRPERATTPCTP  double precision;
/* Variavei de cursor C_RATTPCTREC*/
   DECLARE   @V_RATTPCTREC_CDFILIAL      VARCHAR(4);
   DECLARE   @V_RATTPCTREC_CDCENTCUST    VARCHAR(4);
   DECLARE   @V_RATTPCTREC_CDFIRATTPCTP  VARCHAR(4);
   DECLARE   @V_RATTPCTREC_VRPERATTPCTP  double precision;


BEGIN

   SELECT @V_CDCENTCUST = MAX(CDCENTCUST)
   FROM   FILIAL
   WHERE  CDFILIAL = @P_CDFILIRAT;

   IF @P_IDENTRSAID = 'E' BEGIN
      /* Para a entrada gera rateio de Contas a pagar*/
      SELECT COUNT(*)
      SELECT @V_RATTPCT = COUNT(*)
      FROM   RATTPCTP
      WHERE  CDTPCTPAGAR = @P_CDTIPOCONTA;
   END;

   IF @V_RATTPCT > 0 BEGIN    /*B*/
            DECLARE C_RATTPCTPAG CURSOR FOR
                    (SELECT CDFILIAL, CDCENTCUST, CDFIRATTPCTP, VRPERATTPCTP
                     FROM   RATTPCTP
                     WHERE  CDTPCTPAGAR = @P_CDTIPOCONTA);
            OPEN C_RATTPCTPAG;
            FETCH NEXT FROM C_RATTPCTPAG INTO @V_RATTPCTPAG_CDFILIAL,
                                              @V_RATTPCTPAG_CDCENTCUST,
                                              @V_RATTPCTPAG_CDFIRATTPCTP,
                                              @V_RATTPCTPAG_VRPERATTPCTP;
            WHILE (@@FETCH_STATUS = 0) BEGIN /*C*/

               SET @V_VALORRAT = (@P_VRCONTA * @V_RATTPCTPAG_VRPERATTPCTP)/100;
               IF @V_RATTPCTPAG_CDFILIAL IS NULL BEGIN /*D*/
                  SET @V_CDFILIAL = @P_CDFILIRAT;
               END
               ELSE
                  SET @V_CDFILIAL = @V_RATTPCTPAG_CDFIRATTPCTP;
               END;/*D*/
               INSERT INTO RATCTPAGAR
                           (CDFILIAL,     NRLANCTONF, NRSEQVENPAG,
                            NRPARCELAPAG, CDCENTCUST, CDFIRATCTPAG,
                            VRRATCCCTPAG)
                VALUES
                    (@P_CDFILIAL,  @P_LANCAMENTO,            @P_NRSEQVENC,
                     @P_NRPARCELA, @V_RATTPCTPAG_CDCENTCUST, @V_CDFILIAL,
                     @V_VALORRAT);

               FETCH NEXT FROM C_RATTPCTPAG INTO @V_RATTPCTPAG_CDFILIAL,
                                                 @V_RATTPCTPAG_CDCENTCUST,
                                                 @V_RATTPCTPAG_CDFIRATTPCTP,
                                                 @V_RATTPCTPAG_VRPERATTPCTP;
             CLOSE C_RATTPCTPAG;
             DEALLOCATE C_RATTPCTPAG;
            END /*C*/ /*Aqui termina o while do RATTPCTPAG*/
   ELSE /*B*/
      IF @V_CDCENTCUST IS NOT NULL BEGIN /*E*/
         INSERT INTO RATCTPAGAR
               (CDFILIAL,     NRLANCTONF, NRSEQVENPAG,
                NRPARCELAPAG, CDCENTCUST, CDFIRATCTPAG,
                VRRATCCCTPAG)
            VALUES
               (@P_CDFILIAL,  @P_LANCAMENTO, @P_NRSEQVENC,
                @P_NRPARCELA, @V_CDCENTCUST, @P_CDFILIRAT,
                @P_VRCONTA);
      END /*E*/
      ELSE
      /* Para a entrada gera rateio de Contas a Receber*/
         SELECT @V_RATTPCT = COUNT(*)
         FROM  RATTPCTR
         WHERE CDTPCTRECEB = @P_CDTIPOCONTA;

         IF @V_RATTPCT > 0 BEGIN /*1*/
            DECLARE C_RATTPCTREC CURSOR FOR
                    (SELECT CDFILIAL, CDCENTCUST, CDFIRATTPCTR, VRPERATTPCTR
                     FROM   RATTPCTR
                     WHERE  CDTPCTRECEB = @P_CDTIPOCONTA);
            OPEN C_RATTPCTREC;
            FETCH NEXT FROM C_RATTPCTREC INTO @V_RATTPCTREC_CDFILIAL,
                                              @V_RATTPCTREC_CDCENTCUST,
                                              @V_RATTPCTREC_CDFIRATTPCTP,
                                              @V_RATTPCTREC_VRPERATTPCTP;
            WHILE (@@FETCH_STATUS = 0) BEGIN /*2*/

               SET @V_VALORRAT = (@P_VRCONTA * @V_RATTPCTREC_VRPERATTPCTP)/100;
               IF @V_RATTPCTREC_CDFILIAL IS NULL BEGIN
                   SET @V_CDFILIAL = @P_CDFILIRAT;
               END
               ELSE
                   SET @V_CDFILIAL = @V_RATTPCTREC_CDFIRATTPCTP;
               END;
               --raise_application_error(-20501, @P_CDFILIRAT, True);
               INSERT INTO RATCTRECEBER
                           (CDFILIAL,     NRLANCTONF, NRSEQVENREC,
                            NRPARCELAREC, CDCENTCUST, CDFIRATCTREC,
                            VRRATCCCTREC)
               VALUES
                    (@P_CDFILIAL,  @P_LANCAMENTO,            @P_NRSEQVENC,
                     @P_NRPARCELA, @V_RATTPCTREC_CDCENTCUST, @V_CDFILIAL,
                     @V_VALORRAT);

                                 FETCH NEXT FROM C_RATTPCTREC INTO @V_RATTPCTREC_CDFILIAL,
                                              @V_RATTPCTREC_CDCENTCUST,
                                              @V_RATTPCTREC_CDFIRATTPCTP,
                                              @V_RATTPCTREC_VRPERATTPCTP;
CLOSE C_RATTPCTREC;
DEALLOCATE C_RATTPCTREC;
            END /*2*//*Aqui termina o while do rec*/
      ELSE /*1*/
         IF @V_CDCENTCUST IS NOT NULL BEGIN /*K*/
            INSERT INTO RATCTRECEBER
               (CDFILIAL,     NRLANCTONF, NRSEQVENREC,
                NRPARCELAREC, CDCENTCUST, CDFIRATCTREC,
                VRRATCCCTREC)
            VALUES
               (@P_CDFILIAL,  @P_LANCAMENTO, @P_NRSEQVENC,
                @P_NRPARCELA, @V_CDCENTCUST, @P_CDFILIRAT,
                @P_VRCONTA);
     END; /*K*/

END;/*END DO BEGIN*/

GO

-- VERSAO --
EXEC ATUVEROBJ 'GERA_RATEIO_CONTA','5.07.009';
GO
